﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

/* Tonasz Ludum Dare 48 */

public class Generator : MonoBehaviour {

	public GameObject[] heads;
	public GameObject[] hands;
	public GameObject[] bodies;
	public GameObject[] legs;
	public GameObject[] weapons;
	public GameObject upgradesFolder;
	public GameObject iconFolder;
	public GameObject[] symbols;
	public GameObject weaponPre;
	List<GameObject> statsIcons = new List<GameObject>();

	public GameObject player;
	RoboStats playerStats;

	GameObject[] upgrades;
	//public Sprite spr2;

	public GameObject robotPrefab;
	//GameObject lastRobot;

	// Use this for initialization
	void Start () {
		playerStats = player.GetComponent<RoboStats>();
	}
	
	// Update is called once per frame
	void Update () {
	
		/*if (Input.GetKeyDown(KeyCode.R)) {
			DestroyLast();
			Generate();
		}*/

		/*if (Input.GetKeyDown(KeyCode.Q)) {
			if (lastRobot!=null) {
				if (weaponAnim == 1)
					lastRobot.transform.FindChild("Weapon").animation.Play("a_slash0");
				if (weaponAnim == 2)
					lastRobot.transform.FindChild("Weapon").animation.Play("a_slash1");
				if (weaponAnim == 3)
					lastRobot.transform.FindChild("Weapon").animation.Play("a_fire");
			}
		}*/
	}

	/*void DestroyLast() {
		if (lastRobot!=null)
			Destroy(lastRobot);
	void Generate() {
		GameObject robot = (GameObject) GameObject.Instantiate(robotPrefab,Vector3.zero,new Quaternion());
		GameObject robotWHolder = robot.transform.FindChild("Weapon").gameObject;

		int headSeed = Random.Range(0,4);
		int bodySeed = Random.Range(0,4);
		int legsSeed = Random.Range(0,2);
		int weaponSeed = Random.Range(0,8);

		GameObject newHead = (GameObject) GameObject.Instantiate(heads[headSeed],heads[headSeed].transform.position,new Quaternion());
		newHead.transform.parent = robot.transform;
		//newHead.GetComponent<SpriteRenderer>().sprite = spr2;
		//newHead.GetComponent<SpriteRenderer>().sprite = (Sprite) Resources.Load("Assets/Sprites/heads.png", typeof(Sprite));
		GameObject newBody = (GameObject) GameObject.Instantiate(bodies[bodySeed],bodies[bodySeed].transform.position,new Quaternion());
		newBody.transform.parent = robot.transform;
		GameObject newHandR = (GameObject) GameObject.Instantiate(hands[0],hands[0].transform.position,new Quaternion());
		newHandR.transform.parent = robot.transform;
		GameObject newHandL = (GameObject) GameObject.Instantiate(hands[1],hands[1].transform.position,new Quaternion());
		newHandL.transform.parent = robot.transform;
		GameObject newLegs = (GameObject) GameObject.Instantiate(legs[legsSeed],legs[legsSeed].transform.position,new Quaternion());
		newLegs.transform.parent = robot.transform;
		GameObject newWeapon = (GameObject) GameObject.Instantiate(weapons[weaponSeed],weapons[weaponSeed].transform.position,weapons[weaponSeed].transform.rotation);
		newWeapon.transform.parent = robotWHolder.transform;
		newWeapon.transform.localPosition = weapons[weaponSeed].transform.position;
		switch (weaponSeed) {
		case 0: case 1: weaponAnim = 1; break;
		case 2: case 3: weaponAnim = 2; break;
		case 4: case 5: weaponAnim = 3; break;
		default: weaponAnim = 0; break;

		}

		lastRobot = robot;
	}*/

	public void ReGenerateEnemy(GameObject robot) {

		for (int loop=robot.transform.childCount-1; loop>=0; loop--) {
				GameObject.Destroy(robot.transform.GetChild(loop).gameObject);		
		}

		GameObject robotWHolder = (GameObject) GameObject.Instantiate( weaponPre, weaponPre.transform.position,new Quaternion());
		robotWHolder.transform.parent = robot.transform;
		robotWHolder.transform.localPosition = weaponPre.transform.position;
		robotWHolder.transform.localScale = Vector3.one;

		int headSeed = Random.Range(0,16);
		int bodySeed = Random.Range(0,16);
		int legsSeed = Random.Range(0,8);
		int weaponSeed = Random.Range(0,4);
		
		GameObject newHead = (GameObject) GameObject.Instantiate(heads[headSeed],heads[headSeed].transform.position,new Quaternion());
		newHead.transform.parent = robot.transform;
		newHead.transform.localPosition = heads[headSeed].transform.position;
		newHead.transform.localScale = Vector3.one;
		GameObject newBody = (GameObject) GameObject.Instantiate(bodies[bodySeed],bodies[bodySeed].transform.position,new Quaternion());
		newBody.transform.parent = robot.transform;
		newBody.transform.localPosition = bodies[bodySeed].transform.position;
		newBody.transform.localScale = Vector3.one;
		GameObject newHandR = (GameObject) GameObject.Instantiate(hands[0],hands[0].transform.position,new Quaternion());
		newHandR.transform.parent = robot.transform;
		newHandR.transform.localPosition = hands[0].transform.position;
		newHandR.transform.localScale = Vector3.one;
		GameObject newHandL = (GameObject) GameObject.Instantiate(hands[1],hands[1].transform.position,new Quaternion());
		newHandL.transform.parent = robot.transform;
		newHandL.transform.localPosition = hands[1].transform.position;
		newHandL.transform.localScale = Vector3.one;
		GameObject newLegs = (GameObject) GameObject.Instantiate(legs[legsSeed],legs[legsSeed].transform.position,new Quaternion());
		newLegs.transform.parent = robot.transform;
		newLegs.transform.localPosition = legs[legsSeed].transform.position;
		newLegs.transform.localScale = Vector3.one;
		GameObject newWeapon = (GameObject) GameObject.Instantiate(weapons[weaponSeed],weapons[weaponSeed].transform.position,weapons[weaponSeed].transform.rotation);
		newWeapon.transform.parent = robotWHolder.transform;
		newWeapon.transform.localPosition = weapons[weaponSeed].transform.position;
		newWeapon.transform.localScale = Vector3.one;


	}

	public void ShowUpgrades(int roundNumber) {
		if (upgrades != null) DestroyUpgrades();
		upgrades = new GameObject[4];
		bool oneClassic = false;
		for (int loop = 0;loop<4;loop++) {
			GameObject pick;
			int categorySeed;
			do {
				categorySeed = Random.Range(0,4);
				int incategoSeed;
				switch (categorySeed) {
				case 0: 
					incategoSeed = Random.Range(0,16);
					pick = heads[incategoSeed];
					break;
				case 1: 
					incategoSeed = Random.Range(0,16);
					pick = bodies[incategoSeed];
					break;
				case 2: 
					incategoSeed = Random.Range(0,8);
					pick = legs[incategoSeed]; 
					break;
				case 3: 
					incategoSeed = Random.Range(0,4);
					pick = weapons[incategoSeed];
					break;
				default: 
					incategoSeed = Random.Range(0,4);
					pick = heads[incategoSeed];
					break;
				}
				if (pick.GetComponent<PartStats>().classic) oneClassic = true;
			} while(oneClassic==false && loop==3);
			upgrades[loop] = (GameObject) GameObject.Instantiate(pick,new Vector3(-9+loop*6,4),new Quaternion());
			upgrades[loop].transform.parent = upgradesFolder.transform;
			upgrades[loop].GetComponent<PartStats>().standardPosition = pick.transform.localPosition;
			upgrades[loop].GetComponent<PartStats>().standardScale = pick.transform.localScale;
			if (categorySeed!=3)
				upgrades[loop].transform.localScale = new Vector3(2,2,1);
			upgrades[loop].renderer.sortingOrder = 80;

			
			bool isClassic = pick.GetComponent<PartStats>().classic;
			int upsCount = Random.Range(roundNumber/5+1,roundNumber/4+1+1);
			if (isClassic && upsCount>1) upsCount -= 1;
			for (int loopStat = 0; loopStat<upsCount; loopStat++) {
				int statType = Random.Range(0,6);
				while (statType==1) statType = Random.Range(0,6);
				int statNumber = Random.Range(roundNumber/4+1,roundNumber/3+2+1);
				if (statType==2) statNumber = Random.Range(roundNumber/6+1,roundNumber/4+1+1);
				if (isClassic && statNumber>1)
					statNumber -= 1;
				if (statNumber>0) {
					AddIcons(loop,loopStat,statType,statNumber);
					switch (statType) {
					case 0: upgrades[loop].GetComponent<PartStats>().hpMax += statNumber; break;
					case 2: upgrades[loop].GetComponent<PartStats>().dmg += statNumber; break;
					case 3: upgrades[loop].GetComponent<PartStats>().speed += statNumber; break;
					case 4: upgrades[loop].GetComponent<PartStats>().arrowNumber += statNumber; break;
					case 5: upgrades[loop].GetComponent<PartStats>().arrowSpace += statNumber; break;
					}
				}
			}
		}
	}

	public void DestroyUpgrades() {
		foreach (GameObject loop in upgrades) {
			if (loop!=null) Destroy(loop);
		}
		upgrades = null;
		DestroyIcons();
	}

	void AddIcons (int column, int verse, int type, int number) {
		for (int loop = 0; loop < number; loop++) {
			GameObject tempIcon = (GameObject) GameObject.Instantiate(symbols[type],new Vector3(-11f+loop*0.8f+column*6f,verse*-0.8f),new Quaternion());
			tempIcon.transform.parent = iconFolder.transform;
			statsIcons.Add (tempIcon);
		}
	}

	void DestroyIcons() {
		foreach (GameObject loop in statsIcons) {
			Destroy(loop);
		}
		statsIcons.Clear();
	}

	public void SetUpgrade(int whichOne) {
		int category = upgrades[whichOne].GetComponent<PartStats>().category;
		Destroy(playerStats.partsList[category]);
		playerStats.partsList[category] = upgrades[whichOne];
		if (category == 3) {
			upgrades[whichOne].transform.parent = player.transform.FindChild("Weapon");
			upgrades[whichOne].renderer.sortingOrder = 51; }
		else {
			upgrades[whichOne].transform.parent = player.transform;
			upgrades[whichOne].renderer.sortingOrder = 50; }
		upgrades[whichOne].transform.localScale = upgrades[whichOne].GetComponent<PartStats>().standardScale;
		upgrades[whichOne].transform.localPosition = upgrades[whichOne].GetComponent<PartStats>().standardPosition;
		upgrades[whichOne] = null;
	}
}
