﻿using UnityEngine;
using System.Collections;

/* Tonasz Ludum Dare 48 */

public class Notes : MonoBehaviour {

	public GameObject arrowsFolder;
	public GameObject[] arrows;
	public GameObject t_hit;
	public GameObject t_miss;

	public GameObject round;
	Round roundS;
	public GameObject playerRobot;

	public AudioClip[] sounds;

	GameObject[] newBeat;
	public int[] newBeatType;
	GameObject t_smth;
	int hitted = 0;
	int beatCount = 0;
	float speed = 0.2f;
	float spaceMod = 1f;
	

	// Use this for initialization
	void Start () {
		roundS = round.GetComponent<Round>();
	}
	
	// Update is called once per frame
	void Update () {

		if (newBeat!=null) {
			Move();
			if (Input.GetKeyDown(KeyCode.UpArrow))
				CheckHit(0);
			if (Input.GetKeyDown(KeyCode.RightArrow))
				CheckHit(1);
			if (Input.GetKeyDown(KeyCode.DownArrow))
				CheckHit(2);
			if (Input.GetKeyDown(KeyCode.LeftArrow))
				CheckHit(3);
		}

	}

	public void Clear() {
		hitted = 0;
		Destroy(t_smth);
		t_smth = null;
	}

	public void NewCombo(int beatCountB) {
		Clear ();
		beatCount = beatCountB;
		newBeat = new GameObject[beatCount];
		newBeatType = new int[beatCount];
		float aktX = 21f;
		for (int loop = 0; loop<beatCount; loop++) {
			int arrowSeed = Random.Range(0,4);
			if (loop>0) aktX += Random.Range(6f*spaceMod,9f*spaceMod);
			newBeat[loop] = (GameObject) GameObject.Instantiate(arrows[arrowSeed],new Vector3(aktX,5),new Quaternion());
			newBeat[loop].transform.parent = arrowsFolder.transform;
			newBeatType[loop] = arrowSeed;
		}
	}

	void Move() {
		foreach (GameObject loopArrow in newBeat) {
			//loopArrow.transform.position += new Vector3(-1*speed*Time.fixedDeltaTime,0);
			loopArrow.transform.position += new Vector3(-1*speed,0);
		}
		if (newBeat[newBeat.Length-1].transform.position.x<=-21f) {
			if (hitted == beatCount)
				THit();
			else TMiss();
		}
	}

	void CheckHit(int key) {
		bool hit = false;
		for (int loop = 0; loop<beatCount; loop++) {
			if (newBeat[loop].transform.position.x < -16.4f && newBeat[loop].transform.position.x > -18.4f) {
				if (newBeatType[loop]==key){
					hit = true;
					audio.PlayOneShot(sounds[key]);
				}
			}
		}
		if (hit)
			hitted ++;
		else TMiss();
	}

	void THit() {
		audio.PlayOneShot(sounds[5]);
		DestroyBeat();
		t_smth = (GameObject) GameObject.Instantiate(t_hit,t_hit.transform.position,new Quaternion());
		roundS.endedNotes(true);
	}
	void TMiss() {
		audio.PlayOneShot(sounds[4]);
		DestroyBeat();
		roundS.endedNotes(false);
		t_smth = (GameObject) GameObject.Instantiate(t_miss,t_miss.transform.position,new Quaternion());
	}

	void DestroyBeat() {
		foreach (GameObject loopArrow in newBeat) {
			Destroy(loopArrow);
		}
		newBeat = null;
	}

	public void UpdateSpeed(float newSpeed) {
		speed = newSpeed;
	}

	public void UpdateSpace(float newSpace) {
		spaceMod = newSpace;
	}
}
