﻿using UnityEngine;
using System.Collections;

public class RoboStats : MonoBehaviour {

	public int hpMax; //0
	public int hpAct;
	public int dmg; //2
	public int speed; //3
	public int arrowNumber; //4
	public int arrowSpace; //5
	public GameObject[] partsList = new GameObject[4];

	// Use this for initialization
	void Start () {
		HpToMax();
	}
	
	// Update is called once per frame
	void Update () {
	}

	public void GetHitted(int dmg) {
		hpAct -= dmg;
	}

	public void HpToMax() {
		hpAct = hpMax;
	}

	public void UpdateStats() {
		hpMax = 2;
		dmg = 1;
		speed = 0;
		arrowNumber = 0;
		arrowSpace = 0;
		PartStats[] partsS = transform.GetComponentsInChildren<PartStats>();
		foreach (PartStats loop in partsS) {
			hpMax += loop.hpMax;
			dmg += loop.dmg;
			speed += loop.speed;
			arrowNumber += loop.arrowNumber;
			arrowSpace += loop.arrowSpace;
		}
	}

	public void UpdateStatsNPC(int round) {
		hpMax = round;
		//dmg = round/3+1;
		dmg = 1;
		speed = round;
		arrowNumber = round;
		arrowSpace = round;
	}

	public bool CheckClasic() {
		PartStats[] partsS = transform.GetComponentsInChildren<PartStats>();
		foreach (PartStats loop in partsS) {
			if (!loop.classic) return false;
		}
		return true;
	}
}
