﻿using UnityEngine;
using System.Collections;

/* Tonasz Ludum Dare 48 */

public class Round : MonoBehaviour {

	public GameObject player;
	RoboStats playerStats;
	public GameObject enemy;
	RoboStats enemyStats;
	public GameObject notes;
	Notes notesS;
	public GameObject[] symbols;
	public GameObject generator;
	Generator generatorS;
	public GameObject iconFolder;
	public GameObject bg0Obj;
	public GameObject bg1Obj;
	public GameObject[] splashObj;
	int actSplashStart = -1;
	int currentSelectedUpgrade = 0;
	public GameObject bgUpgrade;
	public GameObject bgUpgradeTxt;
	bool isSplash4 = false;
	int endStep;
	public GameObject startSplash;
	public GameObject[] end_Objects;
	bool isClassic = false;

	public AudioClip theme;

	public int roundNumber = 1;
		
	GameObject[] hpSymbolsP;
	GameObject[] hpSymbolsE;
	
	int aktArrowNumber = 4;
	int aktDmgPlayer = 1;
	int aktDmgEnemy = 1;

	enum Phases {Splash, Preparation, Notes, BeforeAttack, Attack, Lost, Upgrade, End}
	Phases actPhase;

	bool playerRdy = false;
	bool enemyRdy = false;
	bool playerHitted = false;
	// Use this for initialization
	void Start () {
		notesS = notes.GetComponent<Notes>();
		playerStats = player.GetComponent<RoboStats>();
		enemyStats = enemy.GetComponent<RoboStats>();
		generatorS = generator.GetComponent<Generator>();
		actPhase = Phases.Splash;
		playerRdy = true;
		enemyRdy = true;
		enemy.transform.position = new Vector3(25,-7);
		SetSplash(0);
	}
	
	// Update is called once per frame
	void Update () {
		if (actPhase == Phases.Splash) {
			if (actSplashStart==-1) {
				if (Input.GetKeyDown(KeyCode.RightArrow) || Input.GetKeyDown(KeyCode.DownArrow) || Input.GetKeyDown(KeyCode.LeftArrow) || Input.GetKeyDown(KeyCode.UpArrow)) {
					actSplashStart=0;
					Destroy(startSplash);
					StartTheme();
				}
			} else {
				if (actSplashStart==3) {
					SetSplash(-1);
					LevelStart();
					actPhase = Phases.Preparation;
				}
				else {
					SetSplash(actSplashStart);
					if (Input.GetKeyDown(KeyCode.RightArrow)) {
						actSplashStart++;
					}
					if (Input.GetKeyDown(KeyCode.LeftArrow)) {
						splashObj[actSplashStart].SetActive(false);
						actSplashStart--;
						if (actSplashStart<0) actSplashStart=0;
					}
				}
			}
		}
		if (actPhase == Phases.Preparation) {
			if (Mathf.Abs(player.transform.position.x)<8f) playerRdy = true;
			if (Mathf.Abs(enemy.transform.position.x)<8f) enemyRdy = true;
		}
		//<ROUND>
		if (actPhase == Phases.BeforeAttack) {
			if (Mathf.Abs(player.transform.position.x)<3.2f) playerRdy = true;
			if (Mathf.Abs(enemy.transform.position.x)<3.2f) enemyRdy = true;
		}
		if (playerRdy && enemyRdy && actPhase == Phases.Preparation) {
			RefreshHP();
			StopTheme();
			notesS.NewCombo(aktArrowNumber);
			actPhase = Phases.Notes;
			playerRdy = false;
			enemyRdy = false;
		}
		if (playerRdy && enemyRdy && actPhase == Phases.BeforeAttack) {
			if (playerHitted)
				player.GetComponent<RoboMove>().Attack();
			if (!playerHitted)
				enemy.GetComponent<RoboMove>().Attack();
			actPhase = Phases.Attack;
			playerRdy = false;
			enemyRdy = false;
		}
		if (actPhase == Phases.Attack) {
			if (!player.GetComponentInChildren<Animation>().isPlaying) playerRdy = true;
			if (!enemy.GetComponentInChildren<Animation>().isPlaying) enemyRdy = true;
		}
		if (playerRdy && enemyRdy && actPhase == Phases.Attack) {
			if (playerHitted) {
				enemyStats.GetHitted(aktDmgPlayer);
				RefreshHP();
			}
			if (!playerHitted) {
				playerStats.GetHitted(aktDmgEnemy);
				RefreshHP();
			}
			if (playerStats.hpAct<=0) {
				StartTheme();
				LostGame();
			}
			else if (enemyStats.hpAct<=0) {
				StartTheme();
				GoToUpgrades();
			} 
			else {
				player.GetComponent<RoboMove>().blockedOwnAnim = false;
				enemy.GetComponent<RoboMove>().blockedOwnAnim = false;
				notesS.NewCombo(aktArrowNumber);
				actPhase = Phases.Notes;
				playerRdy = false;
				enemyRdy = false;
			}
		}
		//</ROUND>
		if (actPhase==Phases.Lost) {
			if (Input.GetKeyDown(KeyCode.RightArrow) || Input.GetKeyDown(KeyCode.DownArrow) || Input.GetKeyDown(KeyCode.LeftArrow) || Input.GetKeyDown(KeyCode.UpArrow)) {
				Application.LoadLevel(Application.loadedLevel);
			}
		}
		if (actPhase==Phases.Upgrade) {
			if (isSplash4) {
				if (Input.GetKeyDown(KeyCode.RightArrow) || Input.GetKeyDown(KeyCode.DownArrow) || Input.GetKeyDown(KeyCode.LeftArrow) || Input.GetKeyDown(KeyCode.UpArrow)) {
					isSplash4 = false;
					SetSplash(-1);
				}
			} else {
				bgUpgrade.transform.position = new Vector3(-9f+currentSelectedUpgrade*6,4f);
				if (Input.GetKeyDown(KeyCode.RightArrow)) {
					if (currentSelectedUpgrade < 3) currentSelectedUpgrade ++;
				}
				if (Input.GetKeyDown(KeyCode.LeftArrow)) {
					if (currentSelectedUpgrade > 0) currentSelectedUpgrade --;
				}
				if (Input.GetKeyDown(KeyCode.DownArrow)) {
					generatorS.SetUpgrade(currentSelectedUpgrade);
					generatorS.DestroyUpgrades();
					currentSelectedUpgrade = 0;
					NextRound();
				}
			}
		}
		//the end
		if (actPhase==Phases.End) {
			if (endStep==1) {
				if (Input.GetKeyDown(KeyCode.RightArrow)) {
					end_Objects[1].SetActive(false);
					isClassic = playerStats.CheckClasic();
					if (isClassic) 
						end_Objects[2].SetActive(true);
					else
						end_Objects[3].SetActive(true);
					end_Objects[0].transform.localScale = Vector3.one;
					endStep = 2;
				}
			}
			else if (endStep==2) {
				if (Input.GetKeyDown(KeyCode.RightArrow)) {
					end_Objects[2].SetActive(false);
					end_Objects[3].SetActive(false);
					end_Objects[4].SetActive(true);
					if (isClassic) 
						end_Objects[5].SetActive(true);
					else
						end_Objects[6].SetActive(true);
				}
			}
		}
		
	}

	public void endedNotes(bool hitted) {
		player.GetComponent<RoboMove>().blockedOwnAnim = true;
		player.GetComponent<RoboMove>().MoveTo(-3f);
		enemy.GetComponent<RoboMove>().blockedOwnAnim = true;
		enemy.GetComponent<RoboMove>().MoveTo(3f);
		playerHitted = hitted;
		actPhase = Phases.BeforeAttack;
	}	
	
	void RefreshHP () {
		DestroyHP();
		hpSymbolsP = new GameObject[playerStats.hpMax];
		for (int loop = 0; loop < playerStats.hpMax; loop++) {
			if (loop < playerStats.hpAct)
				hpSymbolsP[loop] = (GameObject) GameObject.Instantiate(symbols[0],new Vector3(-17.5f+loop*1f,11f),new Quaternion());
			else hpSymbolsP[loop] = (GameObject) GameObject.Instantiate(symbols[1],new Vector3(-17.5f+loop*1f,11f),new Quaternion());
			hpSymbolsP[loop].transform.parent = iconFolder.transform;
			hpSymbolsP[loop].transform.localScale = new Vector3(0.5f,0.5f,1f);
		}
		hpSymbolsE = new GameObject[enemyStats.hpMax];
		for (int loop = 0; loop < enemyStats.hpMax; loop++) {
			if (loop < enemyStats.hpAct)
				hpSymbolsE[loop] = (GameObject) GameObject.Instantiate(symbols[0],new Vector3(17.5f-loop*1f,11f),new Quaternion());
			else hpSymbolsE[loop] = (GameObject) GameObject.Instantiate(symbols[1],new Vector3(17.5f-loop*1f,11f),new Quaternion());
			hpSymbolsE[loop].transform.parent = iconFolder.transform;
			hpSymbolsE[loop].transform.localScale = new Vector3(0.5f,0.5f,1f);
		}
	}

	void DestroyHP() {
		if (hpSymbolsP != null) {
			foreach (GameObject loopHP in hpSymbolsP) {
				Destroy(loopHP);
			}
			hpSymbolsP = null;
		}
		if (hpSymbolsE != null) {
			foreach (GameObject loopHP in hpSymbolsE) {
				Destroy(loopHP);
			}
			hpSymbolsE = null;
		}
	}

	void LevelStart() {
		player.GetComponent<RoboMove>().enabled = true;
		enemy.GetComponent<RoboMove>().enabled = true;
		bg1Obj.SetActive(false);
		bg0Obj.SetActive(true);
		enemy.transform.position = new Vector3(17,-7);
	}

	void SetSplash(int active) {
		if (active == -1) {
			for (int loop = 0; loop<5; loop++) {
				splashObj[loop].SetActive(false);
			}
		}
		else splashObj[active].SetActive(true);
	}

	void LostGame() {
		notesS.Clear();
		bg0Obj.SetActive(false);
		bg1Obj.SetActive(true);
		SetSplash(3);
		actPhase = Phases.Lost;
	}

	void GoToUpgrades() {
		notesS.Clear();
		bg0Obj.SetActive(false);
		bg1Obj.SetActive(true);
		actPhase = Phases.Upgrade;
		bgUpgrade.SetActive(true);
		bgUpgradeTxt.SetActive(true);
		generatorS.ShowUpgrades(roundNumber);
		if (roundNumber==1) { SetSplash(4); isSplash4 = true; }
	}

	void NextRound() {		
		roundNumber++;
		if (roundNumber==8) {
			//won the game
			actPhase = Phases.End;
			bg1Obj.SetActive(false);
			bgUpgrade.SetActive(false);
			bgUpgradeTxt.SetActive(false);
			Destroy(enemy);
			Destroy(player.transform.FindChild("Weapon").gameObject);
			player.transform.position = new Vector3(-17,-7);
			DestroyHP();
			end_Objects[0].SetActive(true);
			end_Objects[1].SetActive(true);
			end_Objects[7].SetActive(true);
			end_Objects[8].SetActive(true);
			endStep=1;
		}
		else {
			StopTheme();
			player.GetComponent<RoboMove>().blockedOwnAnim = false;
			enemy.GetComponent<RoboMove>().blockedOwnAnim = false;
			generatorS.ReGenerateEnemy(enemy);
			bg1Obj.SetActive(false);
			bg0Obj.SetActive(true);
			bgUpgrade.SetActive(false);
			bgUpgradeTxt.SetActive(false);
			actPhase = Phases.Notes;
			playerRdy = false;
			enemyRdy = false;
			playerStats.UpdateStats();
			playerStats.HpToMax();
			enemyStats.UpdateStatsNPC(roundNumber);
			enemyStats.HpToMax();
			RefreshHP();
			aktDmgPlayer = playerStats.dmg;
			aktDmgEnemy = enemyStats.dmg;
			aktArrowNumber =  4+enemyStats.arrowNumber-playerStats.arrowNumber;
			if (aktArrowNumber < 1) aktArrowNumber=1;
			notesS.NewCombo(aktArrowNumber);
			//notesS.UpdateSpeed(10f+enemyStats.arrowNumber*1f-playerStats.arrowNumber*1f);
			notesS.UpdateSpeed(0.2f+enemyStats.arrowNumber*0.015f-playerStats.arrowNumber*0.015f);
			if (1f-enemyStats.arrowNumber*0.10f+playerStats.arrowNumber*0.25f > 0.3f)
				notesS.UpdateSpace(1f-enemyStats.arrowNumber*0.10f+playerStats.arrowNumber*0.25f);
			else notesS.UpdateSpace(0.3f);
		}
	}

	void StartTheme() {
		
		notes.audio.loop = true;
		notes.audio.clip = theme;
		notes.audio.Play();

	}

	void StopTheme() {
		
		notes.audio.loop = false;
		notes.audio.Stop();
		
	}
}
